progname=EXE 

CPP_FILES=$(wildcard *.cpp)
TEST_INPUT_FILES=$(wildcard test*.in)

O_FILES=$(patsubst  %.cpp, %.o,  $(CPP_FILES))
S_FILES=$(patsubst  %.cpp, %.s,  $(CPP_FILES))
II_FILES=$(patsubst %.cpp, %.ii, $(CPP_FILES))
TEST_TARGETS=$(patsubst %.in, %, $(TEST_INPUT_FILES))

all: initial_clean test final_clean


initial_clean:
	@echo "Initial Cleaning..."
	@rm -f *.ii *.s *.o 
	@echo "Done."

test: $(TEST_TARGETS)
	@echo "All tests passed successfully."

test%: $(progname)
	@echo "Testing $@..."
	@./$(progname) < $@.in > $@.out || echo "$(progname) returned non-zero"
	@diff $@.out $@.expected > /dev/null 2>&1 && echo PASSED || echo FAILED


$(progname): $(O_FILES) | .gitignore
	@echo "Linking..."
	@g++ -std=c++11  $^ -o $@
	@echo "Build is done."

%.o: %.s
	@echo "Compiling $@..."
	@g++ -std=c++11  -c $^ -o $@

%.s: %.ii
	@echo "Assempling $@..."
	@g++ -std=c++11  -S $^ -o $@

%.ii: %.cpp
	@echo "Pre-processing $@..."
	@g++ -std=c++11  -E $< -o $@

.PRECIOUS: $(S_FILES) $(II_FILES)
.SECONDARY: $(S_FILES) $(II_FILES)

.gitignore:
	@echo $(progname) > $@

final_clean:
	@echo "Final Cleaninig..."
	@rm -f *.ii *.s *.o .gitignore .*.swp  $(progname) #*.out
	@echo "Done."
	@tail test1.out


